(function () {
    "use strict";

    angular.module('core').controller('fornecedorDetailController', controller);
    controller.$inject = ['$scope', '$q', '$timeout', '$alert', '$state', '$stateParams', 'lookupService', 'empresaService', 'contatoService'];

    function controller($scope, $q, $timeout, $alert, $state, $stateParams, lookupService, empresaService, contatoService) {
        $scope.initializeLayout('Fornecedor');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };
        $scope.popups = {
            contatos: { ativo: false },
            fornecedores: { ativo: false },
        };
       
       
        $scope.save = function () { 
            $scope.state.salvando = true;
            empresaService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                        } else {
                            $scope.state.item = response.Data;
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            empresaService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                        } else {
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };
        
        $scope.auxiliar = {
            contatos: { data: [], carregando: false, vazio: true, count: 0, args: { filtro: { Empresa: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 } },
            fornecedores: { data: [], carregando: false, vazio: true, count: 0, args: { matrizID: decodeURIComponent($stateParams.id), skip: 0, take: 999999 } },
            contato: {
                data: [],
                carregando: false,
                vazio: true,
                count: 0,
                args: { filtro: { Empresa: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 },
                getAll: function () {
                    $scope.auxiliar.contato.carregando = true;
                    $scope.auxiliar.contato.vazio = false;
                    contatoService
                        .getAll($scope.auxiliar.contato.args)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                console.error(response.Exception);
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                angular.copy(angular.fromJson(response.Data), $scope.auxiliar.contato.data);
                            }
                            $scope.auxiliar.contato.carregando = false;
                            $scope.auxiliar.contato.vazio = !response.Data.length;
                        },
                        function (_error) {
                            $scope.auxiliar.contato.carregando = false;
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            console.error(_error);
                        });
                },
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContato({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            empresa: {
                lookup: function (chaves) {

                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            marca: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllMarca({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalEmpresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoComposicaoImposto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoComposicaoImposto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            estado: {
                data: [],
                args: {},
                getAll: function () {
                    lookupService
                        .getAllEstado($scope.auxiliar.estado.args)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                angular.copy(angular.fromJson(response.Data), $scope.auxiliar.estado.data);
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
            },
            endereco: {
                prepare: function (index) {
                    empresaService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.state.item.Enderecos[index] = response.Data;
                                $timeout(function () { $('#enderecos [ng-model$="item.Linha2"]').focus(); });
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
                prepareNew: function () {
           
                    empresaService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.state.item = response.Data;
                                $timeout(function () { $('enderecos [ng-model$="item.Tipo"]').focus(); });
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
            }, 

        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            empresaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.getAllFilha = function () {
            $scope.auxiliar.fornecedores.carregando = true;
            $scope.auxiliar.fornecedores.vazio = false;
            empresaService
                .getAllFilha($scope.auxiliar.fornecedores.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.fornecedores.data);
                        }
                        $scope.auxiliar.fornecedores.carregando = false;
                        $scope.auxiliar.fornecedores.vazio = ($scope.auxiliar.fornecedores.data.length == 0);
                    },
                    function (_error) {
                        $scope.auxiliar.fornecedores.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAllContato = function () {
            $scope.auxiliar.contatos.carregando = true;
            $scope.auxiliar.contatos.vazio = false;
            contatoService
                .getAll($scope.auxiliar.contatos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            console.error(response.Exception);
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.contatos.data);
                        }
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.auxiliar.contatos.vazio = !response.Data.length;
                    },
                    function (_error) {
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        }

        $scope.refresh = function () {
            $scope.get();
            $scope.auxiliar.estado.getAll();
        };

        $scope.toggleContatos = function () {
            $scope.popups.contatos.ativo = !$scope.popups.contatos.ativo;
            if ($scope.popups.contatos.ativo)
                $scope.getAllContato();
        };
        $scope.toggleFornecedores = function () {
            $scope.popups.fornecedores.ativo = !$scope.popups.fornecedores.ativo;
            if ($scope.popups.fornecedores.ativo)
                $scope.getAllFilha();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();